﻿package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	

	public class Zoomer extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		private var cloned:BitmapData;
		private var upground:Bitmap;
		private var counter:Number = 0;
		public function Zoomer()
		{
				addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			setup();
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			stage.addEventListener(MouseEvent.MOUSE_DOWN,down_handler);
			stage.addEventListener(MouseEvent.MOUSE_UP,up_handler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			while(numChildren>0){
				this.removeChildAt(0);
			}
			data = null;
			
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			background = new Bitmap(data);
			addChild(background);
		}
		
		private function down_handler(e:MouseEvent):void
		{
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function up_handler(e:MouseEvent):void
		{
			removeEventListener(Event.ENTER_FRAME,enterHandler);
			setup();
		}
		
		private function enterHandler(e:Event):void
		{
			if(data == null){
				setup();
			}
			if(counter>20){
				counter = 0;
			}else{
				counter++;
			}
			var my_drawer:Sprite = buildDrawer();
			var support:Sprite = new Sprite();
			my_drawer.x = stage.stageWidth/2;
			my_drawer.y = stage.stageHeight/6;
			my_drawer.scaleX=my_drawer.scaleY=1;
			support.addChild(my_drawer);
			data.draw(support);
			cloned = data.clone();
			var mul:uint = 0x10;
			data.merge(cloned,new Rectangle (0,0,stage.stageWidth/180,stage.stageHeight/20),new Point(counter,counter-30),mul,mul,mul,mul);
			
		}
		private function buildDrawer():Sprite
		{
			drawer = new Sprite();
			drawer.graphics.beginFill(0x000000,.1);
			drawer.graphics.drawCircle(-stage.stageHeight,-stage.stageWidth, stage.x);
			drawer.graphics.drawRect(-stage.stageWidth/2,-stage.stageHeight/20,stage.stageWidth,2);
			drawer.graphics.beginFill(0xffffff,.4);
			drawer.graphics.drawRect(stage.stageWidth/2-360,-stage.stageHeight/360,5,stage.stageHeight);
			drawer.graphics.beginFill(0x000000,.4);
			drawer.graphics.drawRect(-stage.stageWidth,stage.stageHeight/2-100,stage.stageWidth,5);
			drawer.graphics.endFill();
			drawer.rotation = Math.random()*360;
			return drawer;
		}
		
	}
}